# On reprogramme la fonction plot.pta                              

plot.pta <- function (x, xax = 1, yax = 2, option = 1:4, clabel = 1, csub = 1.5, clabel_cor= 1, possub3="topleft", arr=FALSE, cpoint=0,  coulind=c(rep("blue",nrow(x$li[, c(xax, yax)]))), coulvar=c(rep("green",nrow(x$co[, c(xax, yax)]))), coultab=c(rep("red",length(x$tab.names))),posigraph2 = "bottomright", cpoints=1,...)
{
    if (!inherits(x, "pta"))
        stop("Object of type 'pta' expected")
    nf <- x$nf
    if (xax > nf)
        stop("Non convenient xax")
    if (yax > nf)
        stop("Non convenient yax")
    def.par <- par(no.readonly = TRUE)
    on.exit(par(def.par))
    mfrow <- n2mfrow(length(option))
    par(mfrow = mfrow)
    for (j in option) {
        if (j == 1) {
            coolig <- x$RV.coo[, c(1, 2)]
            s.corcircle(coolig, label = x$tab.names, cgrid = 0,
                sub = "Interstructure", csub = csub, clabel=clabel, possub = "topleft",
                full = TRUE, coul=coultab)
            l0 <- length(x$RV.eig)
            add.scatter.eig(x$RV.eig, l0, 1, 2, posi = "bottomleft",
                ratio = 1/4)
        }
        if (j == 2) {
            coolig <- x$li[, c(xax, yax)]
            s.label(coolig, sub = "Compromise", csub = csub, clabel=clabel, cpoint=cpoints, possub = "topleft", coul=coulind
                )
            add.scatter.eig(x$eig, x$nf, xax, yax, posi = posigraph2,
                ratio = 1/4)
        }
        if (j == 3) {
            cooco <- x$co[, c(xax, yax)]
            s.arrow(cooco, sub = "Compromise", csub = csub, possub = possub3, arr=arr, cpoint=cpoint, clabel = clabel_cor ,coul=coulvar)
        }
        if (j == 4) {
            plot(x$tabw, x$cos2, xlab = "Tables weights", ylab = "Cos 2")
            scatterutil.grid(0)
            title(main = "Typological value")
            par(xpd = TRUE)
            scatterutil.eti(x$tabw, x$cos2, label = x$tab.names, clabel=clabel,
            coul = coultab)
        }
    }
}

# On reprogramme la fonction s.corcircle

s.corcircle = function (dfxy, xax = 1, yax = 2, label = row.names(dfxy), clabel = 1,
    grid = TRUE, sub = "", csub = 1, possub = "bottomleft", cgrid = 0,
    fullcircle = TRUE, box = FALSE, add.plot = FALSE, coul=c(rep("black",nrow(dfxy))), coulsub="black", lenlen=.1)
{
    arrow1 <- function(x0, y0, x1, y1, len = lenlen, ang = 15, lty = 1,
        edge) {
        d0 <- sqrt((x0 - x1)^2 + (y0 - y1)^2)
        if (d0 < 1e-07)
            return(invisible())
        segments(x0, y0, x1, y1, lty = lty)
        h <- strheight("A", cex = par("cex"))
        if (d0 > 2 * h) {
            x0 <- x1 - h * (x1 - x0)/d0
            y0 <- y1 - h * (y1 - y0)/d0
            if (edge)
                arrows(x0, y0, x1, y1, ang = ang, len = len,
                  lty = 1)
        }
    }
    scatterutil.circ <- function(cgrid, h) {
        cc <- seq(from = -1, to = 1, by = h)
        col <- "lightgray"
        lty <- 1
        for (i in 1:(length(cc))) {
            x <- cc[i]
            a1 <- sqrt(1 - x * x)
            a2 <- (-a1)
            segments(x, a1, x, a2, col = col)
            segments(a1, x, a2, x, col = col)
        }
        symbols(0, 0, circles = 1, inches = FALSE, add = TRUE)
        segments(-1, 0, 1, 0)
        segments(0, -1, 0, 1)
        if (cgrid <= 0)
            return(invisible())
        cha <- paste("d = ", h, sep = "")
        cex0 <- par("cex") * cgrid
        xh <- strwidth(cha, cex = cex0)
        yh <- strheight(cha, cex = cex0) + strheight(" ", cex = cex0)/2
        x0 <- strwidth(" ", cex = cex0)
        y0 <- strheight(" ", cex = cex0)/2
        x1 <- par("usr")[2]
        y1 <- par("usr")[4]
        rect(x1 - x0, y1 - y0, x1 - xh - x0, y1 - yh - y0, col = "white",
            border = 0)
        text(x1 - xh/2 - x0/2, y1 - yh/2 - y0/2, cha, cex = cex0)
    }
    origin <- c(0, 0)
    df <- data.frame(dfxy)
    if (!is.data.frame(df))
        stop("Non convenient selection for df")
    if ((xax < 1) || (xax > ncol(df)))
        stop("Non convenient selection for xax")
    if ((yax < 1) || (yax > ncol(df)))
        stop("Non convenient selection for yax")
    if (!is.null(label))
        showpoint <- FALSE
    x <- df[, xax]
    y <- df[, yax]
    if (add.plot) {
        for (i in 1:length(x)) arrow1(0, 0, x[i], y[i], len = lenlen,
            ang = 15, edge = TRUE)
        if (clabel > 0)
            scatterutil.eti.circ(x, y, label, clabel, coul=coul)
        return(invisible())
    }
    opar <- par(mar = par("mar"))
    on.exit(par(opar))
    par(mar = c(0.1, 0.1, 0.1, 0.1))
    x1 <- x
    y1 <- y
    x1 <- c(x1, -0.01, +0.01)
    y1 <- c(y1, -0.01, +0.01)
    if (fullcircle) {
        x1 <- c(x1, -1, 1)
        y1 <- c(y1, -1, 1)
    }
    x1 <- c(x1 - diff(range(x1)/20), x1 + diff(range(x1))/20)
    y1 <- c(y1 - diff(range(y1)/20), y1 + diff(range(y1))/20)
    plot(x1, y1, type = "n", ylab = "", asp = 1, xaxt = "n",
        yaxt = "n", frame.plot = FALSE)
    if (grid)
        scatterutil.circ(cgrid = cgrid, h = 0.2)
    for (i in 1:length(x)) arrow1(0, 0, x[i], y[i], len = lenlen,
        ang = 15, edge = TRUE)
    if (clabel > 0)
        scatterutil.eti.circ(x, y, label, clabel, origin, coul=coul)
    if (csub > 0)
        scatterutil.sub(sub, csub, possub, coulsub=coulsub)
    if (box)
        box()
    invisible(match.call())
}

# On reprogramme la fonction scatterutil.sub

scatterutil.sub <- function (cha, csub, possub = "bottomleft", coulsub="black") 
{
    cha <- as.character(cha)
    if (length(cha) == 0) 
        return(invisible())
    if (is.null(cha)) 
        return(invisible())
    if (is.na(cha)) 
        return(invisible())
    if (any(cha == "")) 
        return(invisible())
    if (csub == 0) 
        return(invisible())
    cex0 <- par("cex") * csub
    cha <- paste(" ", cha, " ", sep = "")
    xh <- strwidth(cha, cex = cex0)
    yh <- strheight(cha, cex = cex0) * 5/3
    if (possub == "bottomleft") {
        x1 <- par("usr")[1]
        y1 <- par("usr")[3]
        rect(x1, y1, x1 + xh, y1 + yh, col = "white", border = 0)
        text(x1 + xh/2, y1 + yh/2, cha, cex = cex0, col=coulsub)
    }
    else if (possub == "topleft") {
        x1 <- par("usr")[1]
        y1 <- par("usr")[4]
        rect(x1, y1, x1 + xh, y1 - yh, col = "white", border = 0)
        text(x1 + xh/2, y1 - yh/2, cha, cex = cex0, col=coulsub)
    }
    else if (possub == "bottomright") {
        x1 <- par("usr")[2]
        y1 <- par("usr")[3]
        rect(x1, y1, x1 - xh, y1 + yh, col = "white", border = 0)
        text(x1 - xh/2, y1 + yh/2, cha, cex = cex0, col=coulsub)
    }
    else if (possub == "topright") {
        x1 <- par("usr")[2]
        y1 <- par("usr")[4]
        rect(x1, y1, x1 - xh, y1 - yh, col = "white", border = 0)
        text(x1 - xh/2, y1 - yh/2, cha, cex = cex0, col=coulsub)
    }
}

# On reprogramme la fonction scatterutil.eti.circ

scatterutil.eti.circ <- function (x, y, label, clabel, origin = c(0, 0), boxes = TRUE, coul=c(rep("black",length(x))))
{
    if (is.null(label))
        return(invisible())
    if (any(is.na(label)))
        return(invisible())
    if (any(label == ""))
        return(invisible())
    xref <- x - origin[1]
    yref <- y - origin[2]
    for (i in 1:(length(x))) {
        cha <- as.character(label[i])
        cha <- paste(" ", cha, " ", sep = "")
        cex0 <- par("cex") * clabel
        xh <- strwidth(cha, cex = cex0)
        yh <- strheight(cha, cex = cex0) * 5/6
        if ((xref[i] > yref[i]) & (xref[i] > -yref[i])) {
            x1 <- x[i] + xh/2
            y1 <- y[i]
        }
        else if ((xref[i] > yref[i]) & (xref[i] <= (-yref[i]))) {
            x1 <- x[i]
            y1 <- y[i] - yh
        }
        else if ((xref[i] <= yref[i]) & (xref[i] <= (-yref[i]))) {
            x1 <- x[i] - xh/2
            y1 <- y[i]
        }
        else if ((xref[i] <= yref[i]) & (xref[i] > (-yref[i]))) {
            x1 <- x[i]
            y1 <- y[i] + yh
        }
        if (boxes) {
            rect(x1 - xh/2, y1 - yh, x1 + xh/2, y1 + yh, col = "white",
                border = 1)
        }
        text(x1, y1, cha, cex = cex0, col=coul[i])
    }
}

# On reprogramme la fonction s.label

s.label <- function (dfxy, xax = 1, yax = 2, label = row.names(dfxy), clabel = 1,
    pch = 20, cpoint = if (clabel == 0) cpoints else 0, boxes = TRUE,
    neig = NULL, cneig = 2, xlim = NULL, ylim = NULL, grid = TRUE,
    addaxes = TRUE, cgrid = 1, include.origin = TRUE, origin = c(0,
        0), sub = "", csub = 1.25, possub = "bottomleft", pixmap = NULL,
    contour = NULL, area = NULL, add.plot = FALSE, coul=c(rep("black",nrow(dfxy))))
{
    dfxy <- data.frame(dfxy)
    opar <- par(mar = par("mar"))
    on.exit(par(opar))
    par(mar = c(0.1, 0.1, 0.1, 0.1))
    coo <- scatterutil.base(dfxy = dfxy, xax = xax, yax = yax,
        xlim = xlim, ylim = ylim, grid = grid, addaxes = addaxes,
        cgrid = cgrid, include.origin = include.origin, origin = origin,
        sub = sub, csub = csub, possub = possub, pixmap = pixmap,
        contour = contour, area = area, add.plot = add.plot)
    if (!is.null(neig)) {
        if (is.null(class(neig)))
            neig <- NULL
        if (class(neig) != "neig")
            neig <- NULL
        deg <- attr(neig, "degrees")
        if ((length(deg)) != (length(coo$x)))
            neig <- NULL
    }
    if (!is.null(neig)) {
        fun <- function(x, coo) {
            segments(coo$x[x[1]], coo$y[x[1]], coo$x[x[2]], coo$y[x[2]],
                lwd = par("lwd") * cneig)
        }
        apply(unclass(neig), 1, fun, coo = coo)
    }
    if (clabel > 0)
        scatterutil.eti(coo$x, coo$y, label, clabel, boxes, coul=coul)
    if (cpoint > 0 & clabel < 1e-06)
        points(coo$x, coo$y, pch = pch, cex = par("cex") * cpoint, col=coul)
    box()
    invisible(match.call())
}

# On reprogramme la fonction s.arrow

s.arrow <- function (dfxy, xax = 1, yax = 2, label = row.names(dfxy), clabel = 1,
    pch = 20, cpoint = 0, boxes = TRUE, edge = TRUE, arr=TRUE, origin = c(0,
        0), xlim = NULL, ylim = NULL, grid = TRUE, addaxes = TRUE,
    cgrid = 1, sub = "", csub = 1.25, possub = "bottomleft",
    pixmap = NULL, contour = NULL, area = NULL, add.plot = FALSE, coulsub="black", coul=c(rep("black",length(row.names(dfxy)))))
{
arrow1 <- function(x0, y0, x1, y1, len = 0.1, ang = 15, lty = 1,
        edge, coul="black") {
        d0 <- sqrt((x0 - x1)^2 + (y0 - y1)^2)
        if (d0 < 1e-07)
            return(invisible())
        segments(x0, y0, x1, y1, lty = lty, col=coul)
        h <- strheight("A", cex = par("cex"))
        if (d0 > 2 * h) {
            x0 <- x1 - h * (x1 - x0)/d0
            y0 <- y1 - h * (y1 - y0)/d0
            if (edge)
                arrows(x0, y0, x1, y1, ang = ang, len = len,
                  lty = 1, col=coul)
        }
    }
    dfxy <- data.frame(dfxy)
    opar <- par(mar = par("mar"))
    on.exit(par(opar))
    par(mar = c(0.1, 0.1, 0.1, 0.1))
    coo <- scatterutil.base(dfxy = dfxy, xax = xax, yax = yax,
        xlim = xlim, ylim = ylim, grid = grid, addaxes = addaxes,
        cgrid = cgrid, include.origin = TRUE, origin = origin,
        sub = sub, csub = csub, possub = possub, coulsub = coulsub, pixmap = pixmap,
        contour = contour, area = area, add.plot = add.plot)
    if (grid & !add.plot)
        scatterutil.grid(cgrid)
    if (addaxes & !add.plot)
        abline(h = 0, v = 0, lty = 1)
    if (cpoint > 0 & clabel == 0)
        points(coo$x, coo$y, pch = pch, cex = par("cex") * cpoint, col=coul)
    else
        points(coo$x, coo$y, pch = pch, cex = par("cex") * cpoint, col="black")
    if (arr==TRUE)
    {for (i in 1:(length(coo$x)))
          {if (clabel == 0)
          {arrow1(origin[1], origin[2], coo$x[i], coo$y[i], edge = edge, coul=coul[i])}
          else
          {arrow1(origin[1], origin[2], coo$x[i], coo$y[i], edge = edge, coul="black")}
          }
    }
    if (clabel > 0)
        scatterutil.eti.circ(coo$x, coo$y, label, clabel, origin,
            boxes, coul=coul)
    if (csub > 0)
        scatterutil.sub(sub, csub, possub, coulsub=coulsub)
    box()
    invisible(match.call())
}

# On reprogramme la fonction kplot.pta

kplot.pta <- function (object, xax = 1, yax = 2, which.tab = 1:nrow(object$RV), mfrow = NULL, xlim_ind = NULL, ylim_ind = NULL, xlim_var = NULL, ylim_var = NULL, which.graph = 1:4, clabel = 1, cpoint = 0, csub = 2, possub = "bottomright", ask = par("ask"), edge=TRUE, arr=TRUE, clabel_cor=1, coulind=c(rep("blue",nrow(object$li[, c(xax, yax)]))), coulvar=c(rep("green",nrow(object$co[, c(xax, yax)]))), coultab=c(rep("red",length(1:nrow(object$RV)))),cpoints=1,len=0.1,...) 
{
    if (!inherits(object, "pta")) 
        stop("Object of type 'pta' expected")
    def.par <- par(no.readonly = TRUE)
    on.exit(par(def.par))
    show <- rep(FALSE, 4)
    if (!is.numeric(which.graph) || any(which.graph < 1) || any(which.graph > 
        4)) 
        stop("`which' must be in 1:4")
    show[which.graph] <- TRUE
    if (is.null(mfrow)) {
        mfcol <- c(length(which.tab), length(which.graph))
        par(mfcol = mfcol)
    }
    else par(mfrow = mfrow)
    par(ask = ask)
    if (show[1]) {
        for (ianal in which.tab) {
            coo2 <- object$Tax[object$T4[, 1] == ianal, c(xax, 
                yax)]
            row.names(coo2) <- as.character(1:4)
            s.corcircle(coo2, clabel = clabel, cgrid = 0, sub = row.names(object$RV)[ianal], 
                csub = csub, possub = possub, coulsub=coultab[ianal], lenlen=len)
        }
    }
    if (show[2]) {
        par(mar = c(0.1, 0.1, 0.1, 0.1))
        coo1 <- object$li[, c(xax, yax)]
        cootot <- object$Tli[, c(xax, yax)]
        names(cootot) <- names(coo1)
        coofull <- coo1
        for (i in which.tab) coofull <- rbind.data.frame(coofull, 
            cootot[object$TL[, 1] == i, ])
        for (ianal in which.tab) {
            scatterutil.base(coofull, 1, 2, xlim = xlim_ind, ylim = ylim_ind, 
                grid = TRUE, addaxes = TRUE, cgrid = 1, include.origin = TRUE, 
                origin = c(0, 0), sub = row.names(object$RV)[ianal], 
                csub = csub, possub = possub, pixmap = NULL, 
                contour = NULL, area = NULL, add.plot = FALSE, coulsub=coultab[ianal])
            coo2 <- cootot[object$TL[, 1] == ianal, 1:2]
            s.label(coo2, add.p = TRUE, clabel = clabel, label = row.names(object$Tli)[object$TL[, 
                1] == ianal], coul=coulind, cpoint=cpoints)
        }
    }
    if (show[3]) {
        par(mar = c(0.1, 0.1, 0.1, 0.1))
        coo1 <- object$co[, c(xax, yax)]
        cootot <- object$Tco[, c(xax, yax)]
        names(cootot) <- names(coo1)
        coofull <- coo1
        for (i in which.tab) coofull <- rbind.data.frame(coofull, 
            cootot[object$TC[, 1] == i, ])
        for (ianal in which.tab) {
            scatterutil.base(coofull, xax=1, yax=2, xlim = xlim_var, ylim = ylim_var, 
                grid = TRUE, addaxes = TRUE, cgrid = 1, include.origin = TRUE, 
                origin = c(0, 0), sub = row.names(object$RV)[ianal], 
                csub = csub, possub = possub, coulsub=coultab[ianal], pixmap = NULL, 
                contour = NULL, area = NULL, add.plot = FALSE)
            coo2 <- object$Tco[object$TC[, 1] == ianal, c(xax, 
                yax)]
            s.arrow(coo2, add.p = TRUE, sub = row.names(object$RV)[ianal], 
                csub = csub, possub = possub, cpoint=cpoint, coul=coulvar, coulsub=coultab[ianal], clabel=clabel_cor, arr=arr, edge=edge)
        }
    }
    if (show[4]) {
        for (ianal in which.tab) {
            coo2 <- object$Tcomp[object$T4[, 1] == ianal, c(xax, 
                yax)]
            row.names(coo2) <- as.character(1:4)
            s.corcircle(coo2, clabel = clabel, cgrid = 0, sub = row.names(object$RV)[ianal], 
                csub = csub, possub = possub, coulsub=coultab[ianal], lenlen=len)
        }
    }
}

# On reprogramme la fonction scatterutil.base

scatterutil.base <- function (dfxy, xax, yax, xlim, ylim, grid, addaxes, cgrid, include.origin, 
    origin, sub, csub, possub, pixmap, contour, area, add.plot, coulsub="black") 
{
    df <- data.frame(dfxy)
    if (!is.data.frame(df)) 
        stop("Non convenient selection for df")
    if ((xax < 1) || (xax > ncol(df))) 
        stop("Non convenient selection for xax")
    if ((yax < 1) || (yax > ncol(df))) 
        stop("Non convenient selection for yax")
    x <- df[, xax]
    y <- df[, yax]
    if (is.null(xlim)) {
        x1 <- x
        if (include.origin) 
            x1 <- c(x1, origin[1])
        x1 <- c(x1 - diff(range(x1)/10), x1 + diff(range(x1))/10)
        xlim <- range(x1)
    }
    if (is.null(ylim)) {
        y1 <- y
        if (include.origin) 
            y1 <- c(y1, origin[2])
        y1 <- c(y1 - diff(range(y1)/10), y1 + diff(range(y1))/10)
        ylim <- range(y1)
    }
    if (!is.null(pixmap)) {
        if (is.null(class(pixmap))) 
            pixmap <- NULL
        if (is.na(charmatch("pixmap", class(pixmap)))) 
            pixmap <- NULL
    }
    if (!is.null(pixmap)) {
        dimobj <- attr(pixmap, "dim")
    }
    if (!is.null(contour)) {
        if (!is.data.frame(contour)) 
            contour <- NULL
        if (ncol(contour) != 4) 
            contour <- NULL
    }
    if (!is.null(area)) {
        if (!is.data.frame(area)) 
            area <- NULL
        if (!is.factor(area[, 1])) 
            area <- NULL
        if (ncol(area) < 3) 
            area <- NULL
    }
    if (!add.plot) 
        plot.default(0, 0, type = "n", asp = 1, xlab = "", ylab = "", 
            xaxt = "n", yaxt = "n", xlim = xlim, ylim = ylim, 
            xaxs = "i", yaxs = "i", frame.plot = FALSE)
    if (!is.null(pixmap)) {
        plot(pixmap, add = TRUE)
    }
    if (!is.null(contour)) {
        apply(contour, 1, function(x) segments(x[1], x[2], x[3], 
            x[4], lwd = 1))
    }
    if (grid & !add.plot) 
        scatterutil.grid(cgrid)
    if (addaxes & !add.plot) 
        abline(h = 0, v = 0, lty = 1)
    if (!is.null(area)) {
        nlev <- nlevels(area[, 1])
        x1 <- area[, 2]
        x2 <- area[, 3]
        for (i in 1:nlev) {
            lev <- levels(area[, 1])[i]
            a1 <- x1[area[, 1] == lev]
            a2 <- x2[area[, 1] == lev]
            polygon(a1, a2)
        }
    }
    if (csub > 0) 
        scatterutil.sub(sub, csub, possub, coulsub=coulsub)
    return(list(x = x, y = y))
}



table.cont <- function (df, x = 1:ncol(df), y = 1:nrow(df), row.labels = row.names(df), 
    col.labels = names(df), clabel.row = 1, clabel.col = 1, abmean.x = FALSE, 
    abline.x = FALSE, abmean.y = FALSE, abline.y = FALSE, csize = 1, 
    clegend = 0, grid = TRUE, coul_rec="white") 
{
    opar <- par(mai = par("mai"), srt = par("srt"))
    on.exit(par(opar))
    if (any(df < 0)) 
        stop("Non negative values expected")
    N <- sum(df)
    df <- df/sum(df)
    table.prepare(x = x, y = y, row.labels = row.labels, col.labels = col.labels, 
        clabel.row = clabel.row, clabel.col = clabel.col, grid = grid, 
        pos = "leftbottom")
    xtot <- x[col(as.matrix(df))]
    ytot <- y[row(as.matrix(df))]
    coeff <- diff(range(x))/15
    z <- unlist(df)
    sq <- sqrt(abs(z))
    w1 <- max(sq)
    sq <- csize * coeff * sq/w1
    for (i in 1:length(z)) symbols(xtot[i], ytot[i], squares = sq[i], 
        bg = coul_rec, fg = 1, add = TRUE, inch = FALSE)
    f1 <- function(x) {
        w1 <- weighted.mean(val, x)
        val <- (val - w1)^2
        w2 <- sqrt(weighted.mean(val, x))
        return(c(w1, w2))
    }
    if (abmean.x) {
        val <- y
        w <- t(apply(df, 2, f1))
        points(x, w[, 1], pch = 20, cex = 2)
        segments(x, w[, 1] - w[, 2], x, w[, 1] + w[, 2])
    }
    if (abmean.y) {
        val <- x
        w <- t(apply(df, 1, f1))
        points(w[, 1], y, pch = 20, cex = 2)
        segments(w[, 1] - w[, 2], y, w[, 1] + w[, 2], y)
    }
    df <- as.matrix(df)
    x <- x[col(df)]
    y <- y[row(df)]
    df <- as.vector(df)
    if (abline.x) {
        abline(lm(y ~ x, wei = df))
    }
    if (abline.y) {
        w <- coefficients(lm(x ~ y, wei = df))
        if (w[2] == 0) 
            abline(h = w[1])
        else abline(c(-w[1]/w[2], 1/w[2]))
    }
    br0 <- pretty(z, 4)
    l0 <- length(br0)
    br0 <- (br0[1:(l0 - 1)] + br0[2:l0])/2
    sq0 <- sqrt(abs(br0))
    sq0 <- csize * coeff * sq0/w1
    sig0 <- sign(br0)
    if (clegend > 0) 
        scatterutil.legend.bw.square(br0, sq0, sig0, clegend)
}




add.scatter <- function(func, posi = c("bottomleft", "bottomright", "topleft", 
    "topright", "bottomcenter"), ratio = 0.2, inset = 0.01, bg.col = "white") 
{
    if (tolower(posi[1]) == "none") 
        return()
    if (ratio > 0.99) 
        ratio <- 0.99
    if (ratio < 0) 
        ratio <- 0.2
    if (length(inset) == 2) {
        inset.x <- inset[1]
        inset.y <- inset[2]
    }
    else {
        inset.x <- inset[1]
        inset.y <- inset[1]
    }
    inset[inset < 0] <- 0
    plotreg0 <- par("plt")
    plotreg <- plotreg0 + c(inset.x, -inset.x, inset.y, -inset.y)
    on.exit(par(plt = plotreg0))
    posi <- tolower(posi[1])
    if (posi == "bottomleft" || posi == "bottom") {
        x1 <- plotreg[1]
        y1 <- plotreg[3]
    }
    else if (posi == "topleft" || posi == "top") {
        x1 <- plotreg[1]
        y1 <- plotreg[4] - ratio
    }
    else if (posi == "bottomright") {
        x1 <- plotreg[2] - ratio
        y1 <- plotreg[3]
    }
    else if (posi == "bottomcenter") {
        x1 <- (plotreg[1] + plotreg[2] - ratio)/2
        y1 <- plotreg[3]
    }
    else if (posi == "topright") {
        x1 <- plotreg[2] - ratio
        y1 <- plotreg[4] - ratio
    }
    else stop("Unknown position required")
    x2 <- x1 + ratio
    y2 <- y1 + ratio
    par(plt = c(x1, x2, y1, y2), new = TRUE)
    plot.new()
    polygon(c(-0.1, 1.1, 1.1, -0.1), c(-0.1, -0.1, 1.1, 1.1), 
        border = NA, col = bg.col)
    par(plt = c(x1, x2, y1, y2), new = TRUE)
    eval(func)
    return(invisible(match.call()))
}